package com.hai.dao;

import com.hai.entity.HighCouponPackageRecord;
import com.hai.entity.HighCouponPackageRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighCouponPackageRecordMapper extends HighCouponPackageRecordMapperExt {
    @SelectProvider(type=HighCouponPackageRecordSqlProvider.class, method="countByExample")
    long countByExample(HighCouponPackageRecordExample example);

    @DeleteProvider(type=HighCouponPackageRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighCouponPackageRecordExample example);

    @Insert({
        "insert into high_coupon_package_record (coupon_package_title, coupon_package_id, ",
        "goods_type_name, brand_name, ",
        "order_id, child_order_id, ",
        "price, order_no, ",
        "sales_type, created_user_id, ",
        "created_time, updated_user_id, ",
        "updated_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{couponPackageTitle,jdbcType=VARCHAR}, #{couponPackageId,jdbcType=INTEGER}, ",
        "#{goodsTypeName,jdbcType=VARCHAR}, #{brandName,jdbcType=VARCHAR}, ",
        "#{orderId,jdbcType=INTEGER}, #{childOrderId,jdbcType=INTEGER}, ",
        "#{price,jdbcType=DECIMAL}, #{orderNo,jdbcType=VARCHAR}, ",
        "#{salesType,jdbcType=INTEGER}, #{createdUserId,jdbcType=INTEGER}, ",
        "#{createdTime,jdbcType=TIMESTAMP}, #{updatedUserId,jdbcType=INTEGER}, ",
        "#{updatedTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighCouponPackageRecord record);

    @InsertProvider(type=HighCouponPackageRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighCouponPackageRecord record);

    @SelectProvider(type=HighCouponPackageRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_package_title", property="couponPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="coupon_package_id", property="couponPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_type_name", property="goodsTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="brand_name", property="brandName", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.INTEGER),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.INTEGER),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_type", property="salesType", jdbcType=JdbcType.INTEGER),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighCouponPackageRecord> selectByExample(HighCouponPackageRecordExample example);

    @UpdateProvider(type=HighCouponPackageRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighCouponPackageRecord record, @Param("example") HighCouponPackageRecordExample example);

    @UpdateProvider(type=HighCouponPackageRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighCouponPackageRecord record, @Param("example") HighCouponPackageRecordExample example);
}